/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutObjectVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutTotalVO
 *  com.deepexi.scd.calculate.domain.vo.report.ExportReportLayoutVO
 *  com.deepexi.scd.calculate.service.TemplateService
 *  org.springframework.stereotype.Service
 */
package com.deepexi.scd.calculate.service.impl.report;

import com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemVO;
import com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutObjectVO;
import com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutTotalVO;
import com.deepexi.scd.calculate.domain.vo.report.ExportReportLayoutVO;
import com.deepexi.scd.calculate.service.TemplateService;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.stereotype.Service;

@Service
public class IndustryReport65
implements TemplateService {
    private static final String TEMPLATE_NAME = "industryTemplate65.ftl";
    private static final String[] energyType = new String[]{"电力", "热力"};
    private static final String[] dealType = new String[]{"购入", "输出"};

    public String getTemplateName() {
        return TEMPLATE_NAME;
    }

    public void exportTemplate(ExportReportLayoutVO exportReportLayoutVO, Map<String, Object> map) {
        map.put("layoutVO", exportReportLayoutVO);
        map.put("tplName", TEMPLATE_NAME);
        ArrayList tempList = new ArrayList();
        List activityList = (List)exportReportLayoutVO.getTableMap().get("ACTIVITY");
        List totalList = (List)exportReportLayoutVO.getTotalMap().get("TOTAL");
        activityList.forEach(vo -> {
            if ("化石燃料燃烧".equals(vo.getUpperObjectName())) {
                vo.getItemList().forEach(item -> {
                    CalculateReportLayoutTotalVO calculateReportLayoutTotalVO = new CalculateReportLayoutTotalVO();
                    calculateReportLayoutTotalVO.setTotalValueStr(item.getTotalValueStr());
                    calculateReportLayoutTotalVO.setTotalValue(item.getTotalValue());
                    calculateReportLayoutTotalVO.setTotalName(item.getItemName().concat("燃烧排放量"));
                    totalList.add(calculateReportLayoutTotalVO);
                });
                map.put("table2_1", this.buildTable2_1((CalculateReportLayoutObjectVO)vo));
            }
            if ("电力热力".equals(vo.getUpperObjectName())) {
                map.put("table2_2", this.buildTable2_2((CalculateReportLayoutObjectVO)vo));
            }
        });
        map.put("activityList", activityList);
        List factorList = (List)exportReportLayoutVO.getTableMap().get("FACTOR");
        factorList.forEach(factor -> {
            if ("电力热力".equals(factor.getUpperObjectName())) {
                map.put("table3_2", this.buildTable3((CalculateReportLayoutObjectVO)factor));
            }
        });
        map.put("factorList", factorList);
        map.put("totalList", totalList);
    }

    private List<Map<String, Object>> buildTable2_1(CalculateReportLayoutObjectVO vo) {
        ArrayList<Map<String, Object>> result = new ArrayList<Map<String, Object>>();
        vo.getItemList().forEach(item -> {
            HashMap<String, String> map = new HashMap<String, String>();
            map.put("类别", item.getItemName());
            item.getItemValueList().forEach(itemValue -> {
                map.put(itemValue.getValueCode(), itemValue.getValue());
                if ("消耗量".equals(itemValue.getValueCode())) {
                    map.put("单位", itemValue.getValueUnit());
                }
            });
            result.add(map);
        });
        return result;
    }

    private List<CalculateLayoutItemVO> buildTable2_2(CalculateReportLayoutObjectVO vo) {
        HashMap<String, BigDecimal> totalMap = new HashMap<String, BigDecimal>();
        ArrayList<CalculateLayoutItemVO> result = new ArrayList<CalculateLayoutItemVO>();
        for (String deal : dealType) {
            for (String energy : energyType) {
                vo.getItemList().forEach(item -> {
                    if (item.getTableName().contains(deal.concat(energy))) {
                        item.getItemValueList().forEach(itemValue -> {
                            if (itemValue.getValueCode().contains(deal)) {
                                BigDecimal value = new BigDecimal(itemValue.getOriginValue());
                                String key = energy.concat(deal).concat("量");
                                if (totalMap.containsKey(key)) {
                                    totalMap.put(key, ((BigDecimal)totalMap.get(key)).add(value));
                                } else {
                                    totalMap.put(key, value);
                                }
                            }
                        });
                    }
                });
            }
        }
        totalMap.forEach((k, v) -> {
            CalculateLayoutItemVO calculateLayoutItemVO = new CalculateLayoutItemVO();
            calculateLayoutItemVO.setItemName(k);
            calculateLayoutItemVO.setTotalValue(v);
            calculateLayoutItemVO.setTableName(k.contains("电力") ? "MWh" : "GJ");
            result.add(calculateLayoutItemVO);
        });
        return result;
    }

    private List<CalculateLayoutItemVO> buildTable3(CalculateReportLayoutObjectVO factor) {
        HashMap<String, BigDecimal> totalMap = new HashMap<String, BigDecimal>();
        HashMap countMap = new HashMap();
        ArrayList<CalculateLayoutItemVO> result = new ArrayList<CalculateLayoutItemVO>();
        for (String energy : energyType) {
            factor.getItemList().forEach(item -> {
                if (item.getTableName().contains(energy)) {
                    item.getItemValueList().forEach(itemValue -> {
                        if ("排放因子".equals(itemValue.getValueCode())) {
                            BigDecimal value = new BigDecimal(itemValue.getOriginValue());
                            if (totalMap.containsKey(energy)) {
                                totalMap.put(energy, ((BigDecimal)totalMap.get(energy)).add(value));
                            } else {
                                totalMap.put(energy, value);
                            }
                            if (countMap.containsKey(energy)) {
                                countMap.put(energy, ((BigDecimal)countMap.get(energy)).add(BigDecimal.ONE));
                            } else {
                                countMap.put(energy, BigDecimal.ONE);
                            }
                        }
                    });
                }
            });
        }
        totalMap.forEach((k, v) -> {
            BigDecimal count = (BigDecimal)countMap.get(k);
            CalculateLayoutItemVO calculateLayoutItemVO = new CalculateLayoutItemVO();
            calculateLayoutItemVO.setItemName(k);
            calculateLayoutItemVO.setTotalValue(v.divide(count, 5, RoundingMode.HALF_UP));
            calculateLayoutItemVO.setTableName(k.contains("电力") ? "tCO₂/MWh" : "tCO₂/GJ");
            result.add(calculateLayoutItemVO);
        });
        return result;
    }
}

